> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://notion.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://notion.ferndocs.com/_mcp/server.

# Retrieve a block

GET https://api.notion.com/v1/blocks/{block_id}

Retrieves a [Block object](/reference/block) using the ID specified.

If the block returned contains the key `has_children: true`, use the [Retrieve block children](https://developers.notion.com/reference/get-block-children) endpoint to get the list of children.

To retrieve page content for a specific page, use [Retrieve block children](https://developers.notion.com/reference/get-block-children) and set the page ID as the `block_id`.

For more information, read the [Working with page content guide](https://developers.notion.com/docs/working-with-page-content#modeling-content-as-blocks).

This endpoint requires an integration to have read content capabilities. Attempting to call this API without read content capabilities will return an HTTP response with a 403 status code. For more information on integration capabilities, see the [capabilities guide](/reference/capabilities).

### Errors

Returns a 404 HTTP response if the block doesn't exist, or if the integration doesn't have access to the block.

Returns a 400 or 429 HTTP response if the request exceeds the [request limits](/reference/request-limits).

*Note: Each Public API endpoint can return several possible error codes. See the [Error codes section](https://developers.notion.com/reference/status-codes#error-codes) of the Status codes documentation for more information.*

Reference: https://notion.ferndocs.com/reference/retrieve-a-block

## Request

### Path parameters

- `block_id` (string, required) — Identifier for a Notion block

### Headers

- `Notion-Version` (string, required) — The [API version](/reference/versioning) to use for this request. The latest version is `<<latestNotionVersion>>`.

## Response

### 200

200

- `object` (string, optional)
- `id` (string, optional)
- `parent` (V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaParent, optional)
- `created_time` (string, optional)
- `last_edited_time` (string, optional)
- `created_by` (V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaCreatedBy, optional)
- `last_edited_by` (V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaLastEditedBy, optional)
- `has_children` (boolean, optional, default: true)
- `archived` (boolean, optional, default: true)
- `type` (string, optional)
- `heading_2` (V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2, optional)

## Errors

### 400 Bad Request Error

400

## Types

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaParent

- `type` (string, optional)
- `page_id` (string, optional)

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaCreatedBy

- `object` (string, optional)
- `id` (string, optional)

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaLastEditedBy

- `object` (string, optional)
- `id` (string, optional)

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2

- `rich_text` (list of V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2RichTextItems, optional)
- `color` (string, optional)
- `is_toggleable` (boolean, optional, default: true)

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2RichTextItems

- `type` (string, optional)
- `text` (V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2RichTextItemsText, optional)
- `annotations` (V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2RichTextItemsAnnotations, optional)
- `plain_text` (string, optional)
- `href` (any, optional)

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2RichTextItemsText

- `content` (string, optional)
- `link` (any, optional)

### V1BlocksBlockIdGetResponsesContentApplicationJsonSchemaHeading2RichTextItemsAnnotations

- `bold` (boolean, optional, default: true)
- `italic` (boolean, optional, default: true)
- `strikethrough` (boolean, optional, default: true)
- `underline` (boolean, optional, default: true)
- `code` (boolean, optional, default: true)
- `color` (string, optional)

## Examples

**Response**

```json
{
  "Result": {
    "value": "{\n\t\"object\": \"block\",\n\t\"id\": \"c02fc1d3-db8b-45c5-a222-27595b15aea7\",\n\t\"parent\": {\n\t\t\"type\": \"page_id\",\n\t\t\"page_id\": \"59833787-2cf9-4fdf-8782-e53db20768a5\"\n\t},\n\t\"created_time\": \"2022-03-01T19:05:00.000Z\",\n\t\"last_edited_time\": \"2022-03-01T19:05:00.000Z\",\n\t\"created_by\": {\n\t\t\"object\": \"user\",\n\t\t\"id\": \"ee5f0f84-409a-440f-983a-a5315961c6e4\"\n\t},\n\t\"last_edited_by\": {\n\t\t\"object\": \"user\",\n\t\t\"id\": \"ee5f0f84-409a-440f-983a-a5315961c6e4\"\n\t},\n\t\"has_children\": false,\n\t\"archived\": false,\n\t\"type\": \"heading_2\",\n\t\"heading_2\": {\n\t\t\"rich_text\": [\n\t\t\t{\n\t\t\t\t\"type\": \"text\",\n\t\t\t\t\"text\": {\n\t\t\t\t\t\"content\": \"Lacinato kale\",\n\t\t\t\t\t\"link\": null\n\t\t\t\t},\n\t\t\t\t\"annotations\": {\n\t\t\t\t\t\"bold\": false,\n\t\t\t\t\t\"italic\": false,\n\t\t\t\t\t\"strikethrough\": false,\n\t\t\t\t\t\"underline\": false,\n\t\t\t\t\t\"code\": false,\n\t\t\t\t\t\"color\": \"default\"\n\t\t\t\t},\n\t\t\t\t\"plain_text\": \"Lacinato kale\",\n\t\t\t\t\"href\": null\n\t\t\t}\n\t\t],\n\t\t\"color\": \"default\",\n    \"is_toggleable\": false\n\t}\n}"
  }
}
```

**SDK Code**

```javascript Notion SDK for JavaScript
const { Client } = require('@notionhq/client');

const notion = new Client({ auth: process.env.NOTION_API_KEY });

(async () => {
  const blockId = 'c02fc1d3-db8b-45c5-a222-27595b15aea7';
  const response = await notion.blocks.retrieve({
    block_id: blockId,
  });
  console.log(response);
})();
```

```python
import requests

url = "https://api.notion.com/v1/blocks/block_id"

headers = {"Notion-Version": "Notion-Version"}

response = requests.get(url, headers=headers)

print(response.json())
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.notion.com/v1/blocks/block_id"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Notion-Version", "Notion-Version")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.notion.com/v1/blocks/block_id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Notion-Version"] = 'Notion-Version'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.notion.com/v1/blocks/block_id")
  .header("Notion-Version", "Notion-Version")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.notion.com/v1/blocks/block_id', [
  'headers' => [
    'Notion-Version' => 'Notion-Version',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.notion.com/v1/blocks/block_id");
var request = new RestRequest(Method.GET);
request.AddHeader("Notion-Version", "Notion-Version");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Notion-Version": "Notion-Version"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.notion.com/v1/blocks/block_id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```